#pragma once
#include "SimpleTextShape.h"
#include "DrawingShape.h"
#include "XMLUtil.h"
#include <atlcoll.h>
#include "ScriptletContainerFactory.h"

class CXMLTextShape : public CSimpleTextShape
{
public:
	DECLARE_COMPONENT_CREATOR(CXMLTextShape);
	CXMLTextShape(void);
	virtual ~CXMLTextShape(void);
	
	//{kr} ̶Ʈ ڻ  {/kr}
	void	SetHighlightFontColor(COLORREF clrFont);
	COLORREF GetHighlightFontColor();

protected:
	//override
	LPCTSTR GetClassName() { return SCRIPTLET_XMLTEXT_NODE; }
	void	DrawComponent(HDC hDC);
	void	SetText(LPCTSTR pszcText);
	BOOL	GetOrginPreferredSize(LPSIZE lpSize);
	void OnSize(INT32 nWidth, INT32 nHeight);


private:
	COLORREF m_HighlightColor;
	int		m_iWidth;
	int		m_iHeight;

	///< line߿   height
	int		m_iMaxHeight;
	///< line߿   width
	int		m_iMaxWidth;

	///< space between em
	int		m_iBetweenEMSpace;
	///<	calculate text width/height associated with font info
	
	///<	tinyxml object
	TiXmlDocument m_tiXmlDocument;

	TiXmlNode* GetFirstNode();
	TiXmlNode* GetNextNode(TiXmlNode* pNode);
	TiXmlNode* FirstChildElement(TiXmlNode* pNode);
	HFONT _CreateTextFont(HDC hDC);
	BOOL	CalcWidthHeight();
};
